<#
.SYNOPSIS
   Utility functions for DXA.NET Web Application deployment and configuration
.DESCRIPTION
This script is intended to be included ("dot-sourced") in another PowerShell script
#>


function Add-DependentAssembly([xml]$configDoc,[string]$key, $parentElement,[string] $xmlElement)
{
#Write-Host "'$distDestination'  $xmlElement $parentElement"	
$modulesElement = $parentElement.SelectSingleNode("//dependentAssembly")
if($modulesElement)
{
Write-host "founda "
}
else{
	$newE = $configDoc.CreateElement("dependentAssembly","urn:schemas-microsoft-com:asm.v1");
	$parentElement.AppendChild($newE) 
	$newE.InnerXml=$xmlElement
	#Write-Host $parentElement.dependentAssembly.InnerXml
	}
}
function Add-AppSettings([xml]$doc, [string]$appKey,[string] $val)
{
Write-Host "Adding appSettings $appKey $val"	
$setting = $doc.configuration.appSettings.SelectSingleNode("add[@key='$appKey']")
if ($setting)
    {
	Write-Host "in app"
        $settingValue = $setting.GetAttribute("value")
        if ($settingValue -eq $val)
        {
            Write-Host "'$appKey' app setting already contains '$settingValue'."
        }
        else
        {
            $setting.SetAttribute("value",$val)
            Write-Host "updated."
        }
    }
	else
	{
$newAppSetting = $doc.CreateElement("add")
$doc.configuration.appSettings.AppendChild($newAppSetting)
$newAppSetting.SetAttribute("key",$appKey);
$newAppSetting.SetAttribute("value",$val);
}
}

#$distDestination = $distDestination+"\web.config"
#[xml]$doc = Get-Content $distDestination

#Write-Host "'$distDestination' $doc"

function Add-AssemblyBinding([xml] $doc)
{
$assemblyBindingElement = $doc.configuration.runtime.assemblyBinding
if($assemblyBindingElement)
{
	$comment= 	$doc.CreateComment("SocialConnect module dependencies - Start")
	$assemblyBindingElement.AppendChild($comment)
		Add-DependentAssembly $doc "Microsoft.Owin.Security" $assemblyBindingElement "<assemblyIdentity name=""Microsoft.Owin.Security"" publicKeyToken=""31bf3856ad364e35"" culture=""neutral"" /><bindingRedirect oldVersion=""0.0.0.0-3.0.1.0"" newVersion=""3.0.1.0"" />"  
		Add-DependentAssembly  $doc "Microsoft.Owin"  $assemblyBindingElement "<assemblyIdentity name=""Microsoft.Owin"" publicKeyToken=""31bf3856ad364e35"" culture=""neutral"" /><bindingRedirect oldVersion=""0.0.0.0-3.0.1.0"" newVersion=""3.0.1.0"" />"
		Add-DependentAssembly  $doc "Microsoft.Owin.Security.Cookies" $assemblyBindingElement "<assemblyIdentity name=""Microsoft.Owin.Security.Cookies"" publicKeyToken=""31bf3856ad364e35"" culture=""neutral"" /><bindingRedirect oldVersion=""0.0.0.0-3.0.1.0"" newVersion=""3.0.1.0"" />"
			$comment= 	$doc.CreateComment("SocialConnect module dependencies - Ends")
			$assemblyBindingElement.AppendChild($comment)
}
else
{
		Write-Host "assemblyBindingElement not found"
}
}
function Enable-Social([xml] $conficDoc)
{
$comment = 	$conficDoc.CreateComment("SocialConnect module settings - Start")
$conficDoc.configuration.appSettings.AppendChild($comment)

	Add-AppSettings $conficDoc "google-client-id" "556912584897-l00kts1p8jiq79ea5un0p782tb2nlddb.apps.googleusercontent.com"
	Add-AppSettings $conficDoc "google-client-secret" "WVRSI4o4zGzx9yKIGfaT27de"
	Add-AppSettings $conficDoc "facebook-client-id" "10153499596051128"
	Add-AppSettings $conficDoc "facebook-client-secret" "87a5fabd00793b6cea7ecbc41b36b66e"
	
	$comment = 	$conficDoc.CreateComment("SocialConnect module settings - End")
	$conficDoc.configuration.appSettings.AppendChild($comment)
}